#include "ips_audio_alsa_ALSADataLine.h"


/*
static const char *pcm_types[] = {
		"hw",
		"plughw"
};
*/

dataline_t datalines[MAXCARDS][MAXDEVICES][2];


dataline_t* getDataline(JNIEnv *env, jobject obj){
	//jclass class=(*env)->FindClass(env,"ips/audio/alsa/ALSADataLine");
	jclass cls=(*env)->GetObjectClass(env,obj);
	if(cls==NULL){
		fprintf(stderr,"Java Class not found!\n");
		//return NULL;
	}
//	jmethodID pnmId=(*env)->GetMethodID(env,cls,"getNativePointer","()Ljava/nio/ByteBuffer;");
//	if(pnmId==NULL){
//		fprintf(stderr,"Method not found!\n");
//		//return NULL;
//	}
//	//		jmethodID cnmId=(*env)->GetMethodID(env,class,"getCardNumber","()I");
//	//		if(cnmId==NULL){
//	//			fprintf(stderr,"Method not found!\n");
//	//			//return NULL;
//	//		}
//	//		jmethodID dnmId=(*env)->GetMethodID(env,class,"getDeviceNumber","()I");
//	//				if(dnmId==NULL){
//	//					fprintf(stderr,"Method not found!\n");
//	//					//return;
//	//				}
//	jobject pn=(*env)->CallObjectMethod(env,obj,pnmId);

	/* Look for the instance field in cls */
	 jfieldID  fid = (*env)->GetFieldID(env, cls, "nativePointer",
	                              "Ljava/nio/ByteBuffer;");
	     if (fid == NULL) {
	         return NULL; /* failed to find the field */
	     }




	     /* Read the instance field  */
	  jobject pn = (*env)->GetObjectField(env, obj, fid);
	void * pDl=(*env)->GetDirectBufferAddress(env,pn);
	return (dataline_t *)pDl;
	//		jint cn=(*env)->CallIntMethod(env,obj,cnmId);
	//		jint dn=(*env)->CallIntMethod(env,obj,dnmId);
	//		//printf("get dataline :%d %d\n",cn,dn);
	//		return &datalines[cn][dn][0];
}


JNIEXPORT jobject JNICALL Java_ips_audio_alsa_ALSADataLine_nnew(JNIEnv* env, jobject obj){
	void *dlP=malloc(sizeof(dataline_t));
	dataline_t* dl=((dataline_t *)dlP);
	dl->buf=NULL;
	dl->captureBuf=NULL;
	dl->bufLen=0;
	dl->captureBufLen=0;
	return (*env)->NewDirectByteBuffer(env,dlP,sizeof(dataline_t));
}
JNIEXPORT jboolean JNICALL Java_ips_audio_alsa_ALSADataLine_nStart(JNIEnv* env, jobject obj){

	dataline_t* dl=getDataline(env,obj);

	if (snd_pcm_state(dl->pcm) == SND_PCM_STATE_PREPARED) {
		int ret=snd_pcm_start(dl->pcm);
		if(ret==0){
			return JNI_TRUE;
		}
	}

	return JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_ips_audio_alsa_ALSADataLine_nStop(JNIEnv* env, jobject obj){

	dataline_t* dl=getDataline(env,obj);

	if (snd_pcm_state(dl->pcm) == SND_PCM_STATE_RUNNING) {
		int ret=snd_pcm_drop(dl->pcm);
		if(ret==0){
			return JNI_TRUE;
		}
	}
	return JNI_FALSE;
}
JNIEXPORT jint JNICALL Java_ips_audio_alsa_ALSADataLine_available(JNIEnv* env, jobject obj){
	jint avail=0;
	dataline_t* dl=getDataline(env,obj);

	//snd_pcm_status_t *status;
	//snd_pcm_status_alloca(&status);
	snd_pcm_sframes_t availFrames=snd_pcm_avail(dl->pcm);
	//snd_pcm_status(dl->pcm,status);
	//snd_pcm_uframes_t availFrames=snd_pcm_status_get_avail(status);

	if(availFrames>=0){
		long availLong=dl->frameSize * availFrames;
		avail=(jint)availLong;

	}else{
		//fprintf (stderr, "avail error(%s)\n",
		//					 snd_strerror (availFrames));
	}

	if(DEBUG>4) {
		printf("available: %d\n",avail);
		fflush(stdout);
	}
	return avail;
}

JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSADataLine_release(JNIEnv *env, jobject obj){
	dataline_t *dl=getDataline(env,obj);
	if(dl!=NULL){
		if(dl->buf!=NULL){
			free(dl->buf);
		}
		free(dl);
		if(DEBUG>4)printf("dataline released\n");
		fflush(stdout);
	}
}






JNIEXPORT jint JNICALL Java_ips_audio_alsa_ALSADataLine_getBufferSize(JNIEnv *env, jobject obj){

	dataline_t *dl=getDataline(env,obj);
	jint bufferSize=-1;
	unsigned long bufferSizeFrames;

	int ret=snd_pcm_hw_params_get_buffer_size(dl->hw_params,&bufferSizeFrames);
	if(ret==0){
		// TODO unchecked long -> int
		bufferSize=bufferSizeFrames * (dl->frameSize);
	}
	return bufferSize;
}

JNIEXPORT jlong JNICALL Java_ips_audio_alsa_ALSADataLine_getLongFramePosition(JNIEnv *env, jobject obj){

	dataline_t *dl=getDataline(env,obj);
	snd_pcm_sframes_t delay;
	snd_pcm_delay(dl->pcm,&delay);
	//printf("Frames pos transf: %ld delay: %ld\n",dl->framesTransfered,delay);
	jlong framePosition=dl->framesTransfered+delay;
	return framePosition;
}


jboolean ajsCloseDataLine(dataline_t* dl){
	int ret=snd_pcm_close(dl->pcm);
	if(DEBUG){
		printf("Close: %d\n",ret);
		fflush(stdout);
	}
	snd_pcm_hw_params_free(dl->hw_params);
	snd_pcm_hw_free(dl->pcm);
	if(dl->buf!=NULL){
		free(dl->buf);
		dl->buf=NULL;
	}
	if(dl->captureBuf!=NULL){
		free(dl->captureBuf);
		dl->captureBuf=NULL;
	}
	if(ret==0){
		return JNI_TRUE;
	}
	return JNI_FALSE;
}

JNIEXPORT jboolean JNICALL Java_ips_audio_alsa_ALSADataLine_nClose(JNIEnv *env, jobject obj){
	dataline_t* dl=getDataline(env,obj);
	return ajsCloseDataLine(dl);

}




