#ifndef _Included_ips_audio_alsa_ALSADataLine
#define _Included_ips_audio_alsa_ALSADataLine
#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <stdlib.h>
#include <alsa/asoundlib.h>
#include "ips_audio_alsa_ALSAMixer.h"


#ifdef __cplusplus
extern "C" {
#endif

struct dataline{
	snd_ctl_card_info_t *info;
	snd_pcm_info_t *pcminfo;
	snd_pcm_t *pcm;
	snd_pcm_hw_params_t *hw_params;
	unsigned int channels;
	char *pcm_type;
	int frameSize;
	void *captureBuf;
	int captureBufLen;
	void *buf;
	int bufLen;
	snd_pcm_sframes_t framesTransfered;

};

typedef struct dataline dataline_t;

dataline_t* getDataline(JNIEnv *, jobject);
jboolean ajsCloseDataLine(dataline_t*);

JNIEXPORT jobject JNICALL Java_ips_audio_alsa_ALSADataLine_nnew(JNIEnv*, jobject);
JNIEXPORT jboolean JNICALL Java_ips_audio_alsa_ALSADataLine_nStart(JNIEnv*, jobject);
JNIEXPORT jboolean JNICALL Java_ips_audio_alsa_ALSADataLine_nStop(JNIEnv*, jobject);
JNIEXPORT jboolean JNICALL Java_ips_audio_alsa_ALSADataLine_nClose(JNIEnv*, jobject);
JNIEXPORT jint JNICALL Java_ips_audio_alsa_ALSADataLine_getBufferSize(JNIEnv*, jobject);
JNIEXPORT jint JNICALL Java_ips_audio_alsa_ALSADataLine_available(JNIEnv*, jobject);
JNIEXPORT jlong JNICALL Java_ips_audio_alsa_ALSADataLine_getLongFramePosition(JNIEnv *, jobject);
JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSADataLine_release(JNIEnv *, jobject);
JNIEXPORT jint JNICALL Java_ips_audio_alsa_ALSADataLine_getBufferSize(JNIEnv *, jobject);



JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSADataLine_release(JNIEnv *, jobject);

#ifdef __cplusplus
}
#endif

#endif
